
--============================================================
-- number of objects defined in this file

function lua_getNbObjects()
	return 7
end

model = {}
balloon = 0
text_balloon = ''

--============================================================
-- load and save

function callSaveGame()
	setGlobalVar('foundTramwayTicket', foundTramwayTicket)
	saveGame()
end

function callLoadGame()
	loadGame();
	is_game_over = 0
	last_load_or_save_time = getTime()
	foundTramwayTicket = getGlobalVar('foundTramwayTicket')
end

--============================================================
-- cube end

function lua_load_0()
	model.end_cube = load3DModel('models/obj_cube_end/cube_end.obj')
end

function lua_manage_0()
	if getDistanceToPlayer() < 15.0 then
		is_game_over = 1
	end
end

function lua_draw_0()
	draw3DModel(model.end_cube)
end

function lua_unload_0()
	unload3DModel(model.end_cube)
end

--============================================================

function lua_load_1()
	model.tree = load3DModel('models/obj_tree/tree.obj')
end

function lua_manage_1()
	if getDistanceToPlayer() < 10.0 then
		local sx, sy, sz = getPlayerSpeed()
		setPlayerSpeed(-sx, -sy, -sz)
	end
end

function lua_draw_1()
	draw3DModel(model.tree)
end

function lua_unload_1()
	unload3DModel(model.tree)
end

--============================================================

function lua_load_2()
	model.tramway = load3DModel('models/obj_tramway/tramway.obj')
end

function lua_manage_2()
	if getDistanceToPlayer() < 15 then
		if foundTramwayTicket == 1 then
			x,y,z = getCurrentObjectPosition()
			if x < 1800 then
				x = x + getPeriodDuration() / 15000.0
				setCurrentObjectPosition(x,y,z)
				setPlayerPosition(x,y,z)
				if getPlayerMovementType() == 0 then
					setPlayerMovementNone()
				end
			else
				setPlayerMovementWalk()
				x,y,z = getPlayerPosition()
				setPlayerPosition(x,y + 40,z+40)
				foundTramwayTicket = 0
			end
		end
	end
end

function lua_draw_2()
	draw3DModel(model.tramway)
end

function lua_unload_2()
	unload3DModel(model.tramway)
end

--============================================================

--=========================================
-- tramway ticket

function lua_load_3()
	model2 = load3DModel('models/obj_tramway_ticket/tramway_ticket.obj')
end

function lua_manage_3()
	if getDistanceToPlayer() < 15 then
		foundTramwayTicket = 1
	end
end

function lua_draw_3()
	if foundTramwayTicket == 0 then
		draw3DModel(model2)
	end
end

function lua_unload_3()
	unload3DModel(model2)
end

--============================================================
-- magic sphere

nb_visibles_spheres = 0

function lua_load_4()
	model.magic_sphere = load3DModel('models/obj_magic_sphere/magic_sphere.obj')
end

function lua_manage_4()
	if getDistanceToPlayer() < 15 and getTime() > last_load_or_save_time + 1000 and not isEditorMode() then
		callSaveGame()
		description = 'Game saved.'
		time_description = 1000 + getTime()
		last_load_or_save_time = getTime()
	end
end

function lua_draw_4()
	nb_visibles_spheres=nb_visibles_spheres+1
	if getTime() > last_load_or_save_time + 1000 then
		draw3DModel(model.magic_sphere)
	end
end

function lua_unload_4()
	unload3DModel(model.magic_sphere)
end

--============================================================
-- character

function lua_load_5()
	model.character = load3DModel('models/obj_player_magician/player_frame1.obj')
end

function lua_manage_5()
	if getDistanceToPlayer() < 20 then
		text_balloon = 'Hello, how are you my friend?\n\nThere is a "end" cube in this world, \ncan you find it?'
	else
		text_balloon = ''
	end
end

function lua_draw_5()
	rotatePosition(0,90,0)
	draw3DModel(model.character)
end

function lua_unload_5()
	unload3DModel(model.character)
end

--============================================================
-- projectile
projectile_speed={x=0,y=0,z=0}

function lua_load_6()
	model.projectile = load3DModel('models/obj_magic_sphere/magic_sphere.obj')
end

function lua_manage_6()
	local v1,v2,v3,v4,v5 = getObjectLocalVariables()
	--print (v1..','..v2..','..v3..','..v4..','..v5)
	if v4 == 0 then --initialization
		local angle_x, angle_y, dist = getCameraAngleAndDistance()
		v1, v2, v3 = cartesianCoordFromSphericalCoord(angle_x,angle_y, 2.0)
		v4=1
	end
	local duration = getPeriodDuration()/100
	local x,y,z = getCurrentObjectPosition()
	for i = 0, duration, 1 do
		v2=v2-0.00005
		setCurrentObjectPosition(x+v1,y+v2,z+v3)
	end
	local x,y,z = getCurrentObjectPosition()
	if isCollidingPoint(x,y,z) and v4 == 1 then
		removeCubesSphericalHole(x,y,z, 90)
		autoDestroyCurrentObject()
	elseif y < -100 then
		autoDestroyCurrentObject()
	end
	setObjectLocalVariables(v1,v2,v3,v4,v5)
end

function lua_draw_6()
	draw3DModel(model.projectile)
end

function lua_unload_6()
	unload3DModel(model.projectile)
end
